require "webservicex_stock_quote/version"

require 'savon'
require 'nori'
require 'nokogiri'

module WebServiceXStockQuote
  class Quote
    class << self
      attr_accessor :client, :parser
    end

    @client = Savon.client(wsdl: 'http://www.webservicex.net/stockquote.asmx?WSDL')
    @parser = Nori.new( :convert_tags_to => lambda { |t| t.snakecase.to_sym } )

    def Quote.get(symbol)
      response = @client.call(:get_quote, :message => { :symbol => symbol })
      result = @parser.parse(response.body[:get_quote_response][:get_quote_result])

      return result[:stock_quotes][:stock]
    end
  end
end
